package com.example.asynctaskexample;

import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.StrictMode;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;

public class MainActivity extends Activity {
	
	ImageView iv;
	Button loadBtn;
	
	//@SuppressLint("NewApi")
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		iv = (ImageView)findViewById(R.id.myImage);
		loadBtn = (Button)findViewById(R.id.loadImage);
		loadBtn.setOnClickListener(loadBtnListener);
		//StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
		//StrictMode.setThreadPolicy(policy);
	}
	
	private OnClickListener loadBtnListener = new OnClickListener(){
		@Override
		public void onClick(View arg0) {
			new DownloadImageTask().execute();
			
			/*try{
				Thread.sleep(10000);
    			String imgLink = "http://www.comp.hkbu.edu.hk/~sigis/android/public/picture1.jpg";
        		URL url = new URL(imgLink);        		
        		URLConnection conn = url.openConnection();
     	        conn.connect();
     	        InputStream is = conn.getInputStream();
     	        BitmapFactory.Options options = new BitmapFactory.Options();
     	        options.inSampleSize = 4;
     	        Bitmap bm = BitmapFactory.decodeStream(is, null, options);
     	        is.close();
     	        iv.setImageBitmap(bm);
     	    } catch (Exception e) {
     	    }*/
		}
    };

	
	private class DownloadImageTask extends AsyncTask<Integer, Void, Bitmap> {
    	@Override
        protected Bitmap doInBackground(Integer... params) {
    		try{
    			//Thread.sleep(10000);
    			String imgLink = "http://www.comp.hkbu.edu.hk/~sigis/android/public/picture1.jpg";
        		URL url = new URL(imgLink);        		
        		URLConnection conn = url.openConnection();
     	        conn.connect();
     	        InputStream is = conn.getInputStream();
     	        BitmapFactory.Options options = new BitmapFactory.Options();
     	        options.inSampleSize = 4;
     	        Bitmap bm = BitmapFactory.decodeStream(is, null, options);
     	        is.close();
     	        return bm;
     	    } catch (Exception e) {
     	        return null;
     	    }
        }
        @Override 
        protected void onPostExecute(Bitmap result) {
        	super.onPostExecute(result);
        	if(result!=null){
        		iv.setImageBitmap(result);
        	}
        }
    }
}